package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.tags.DamageTypeTags;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.effect.MobEffectInstance;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;

public class CatalyzingAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.CatalyzingAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.CatalyzingAffix::new));
  }
  
  public CatalyzingAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237115_("affix." + getId() + ".desc");
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    return (Component)getDescription(stack, rarity, level);
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat == LootCategory.SHIELD && this.values.containsKey(rarity));
  }
  
  public float onShieldBlock(ItemStack stack, LootRarity rarity, float level, LivingEntity entity, DamageSource source, float amount) {
    if (source.m_269533_(DamageTypeTags.f_268415_)) {
      int time = ((StepFunction)this.values.get(rarity)).getInt(level);
      int modifier = 1 + (int)(Math.log(amount) / Math.log(3.0D));
      entity.m_7292_(new MobEffectInstance(MobEffects.f_19600_, time, modifier));
    } 
    return super.onShieldBlock(stack, rarity, level, entity, source, amount);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
